
#include "amici/symbolic_functions.h"
#include "amici/defines.h" //realtype definition
typedef amici::realtype realtype;
#include <cmath> 

using namespace amici;

namespace amici {

namespace model_model_jakstat_adjoint_o2{

void y_model_jakstat_adjoint_o2(double *y, const realtype t, const realtype *x, const realtype *p, const realtype *k, const realtype *h, const realtype *w) {
  y[0] = p[11]+(p[13]*(x[1]+x[2]*2.0))/p[4];
  y[1] = p[10]+(p[12]*(x[0]+x[1]+x[2]*2.0))/p[4];
  y[2] = amici::spline_pos(t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[3] = (p[13]*x[10])/p[4]+(p[13]*x[11]*2.0)/p[4];
  y[4] = (p[12]*x[9])/p[4]+(p[12]*x[10])/p[4]+(p[12]*x[11]*2.0)/p[4];
  y[6] = (p[13]*x[19])/p[4]+(p[13]*x[20]*2.0)/p[4];
  y[7] = (p[12]*x[18])/p[4]+(p[12]*x[19])/p[4]+(p[12]*x[20]*2.0)/p[4];
  y[9] = (p[13]*x[28])/p[4]+(p[13]*x[29]*2.0)/p[4];
  y[10] = (p[12]*x[27])/p[4]+(p[12]*x[28])/p[4]+(p[12]*x[29]*2.0)/p[4];
  y[12] = (p[13]*x[37])/p[4]+(p[13]*x[38]*2.0)/p[4];
  y[13] = (p[12]*x[36])/p[4]+(p[12]*x[37])/p[4]+(p[12]*x[38]*2.0)/p[4];
  y[15] = (p[13]*x[46])/p[4]+(p[13]*x[47]*2.0)/p[4]-1.0/(p[4]*p[4])*p[13]*(x[1]+x[2]*2.0);
  y[16] = (p[12]*x[45])/p[4]+(p[12]*x[46])/p[4]+(p[12]*x[47]*2.0)/p[4]-1.0/(p[4]*p[4])*p[12]*(x[0]+x[1]+x[2]*2.0);
  y[18] = (p[13]*x[55])/p[4]+(p[13]*x[56]*2.0)/p[4];
  y[19] = (p[12]*x[54])/p[4]+(p[12]*x[55])/p[4]+(p[12]*x[56]*2.0)/p[4];
  y[20] = amici::Dspline_pos(4,t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[21] = (p[13]*x[64])/p[4]+(p[13]*x[65]*2.0)/p[4];
  y[22] = (p[12]*x[63])/p[4]+(p[12]*x[64])/p[4]+(p[12]*x[65]*2.0)/p[4];
  y[23] = amici::Dspline_pos(6,t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[24] = (p[13]*x[73])/p[4]+(p[13]*x[74]*2.0)/p[4];
  y[25] = (p[12]*x[72])/p[4]+(p[12]*x[73])/p[4]+(p[12]*x[74]*2.0)/p[4];
  y[26] = amici::Dspline_pos(8,t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[27] = (p[13]*x[82])/p[4]+(p[13]*x[83]*2.0)/p[4];
  y[28] = (p[12]*x[81])/p[4]+(p[12]*x[82])/p[4]+(p[12]*x[83]*2.0)/p[4];
  y[29] = amici::Dspline_pos(10,t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[30] = (p[13]*x[91])/p[4]+(p[13]*x[92]*2.0)/p[4];
  y[31] = (p[12]*x[90])/p[4]+(p[12]*x[91])/p[4]+(p[12]*x[92]*2.0)/p[4];
  y[32] = amici::Dspline_pos(12,t,5,0.0,p[5],5.0,p[6],1.0E1,p[7],2.0E1,p[8],6.0E1,p[9],0.0,0.0);
  y[33] = (p[13]*x[100])/p[4]+(p[13]*x[101]*2.0)/p[4];
  y[34] = (p[12]*x[99])/p[4]+(p[12]*x[100])/p[4]+(p[12]*x[101]*2.0)/p[4]+1.0;
  y[36] = (p[13]*x[109])/p[4]+(p[13]*x[110]*2.0)/p[4]+1.0;
  y[37] = (p[12]*x[108])/p[4]+(p[12]*x[109])/p[4]+(p[12]*x[110]*2.0)/p[4];
  y[39] = (p[13]*x[118])/p[4]+(p[13]*x[119]*2.0)/p[4];
  y[40] = (x[0]+x[1]+x[2]*2.0)/p[4]+(p[12]*x[117])/p[4]+(p[12]*x[118])/p[4]+(p[12]*x[119]*2.0)/p[4];
  y[42] = (x[1]+x[2]*2.0)/p[4]+(p[13]*x[127])/p[4]+(p[13]*x[128]*2.0)/p[4];
  y[43] = (p[12]*x[126])/p[4]+(p[12]*x[127])/p[4]+(p[12]*x[128]*2.0)/p[4];
  y[45] = (p[13]*x[136])/p[4]+(p[13]*x[137]*2.0)/p[4];
  y[46] = (p[12]*x[135])/p[4]+(p[12]*x[136])/p[4]+(p[12]*x[137]*2.0)/p[4];
  y[48] = (p[13]*x[145])/p[4]+(p[13]*x[146]*2.0)/p[4];
  y[49] = (p[12]*x[144])/p[4]+(p[12]*x[145])/p[4]+(p[12]*x[146]*2.0)/p[4];
  y[51] = (p[13]*x[154])/p[4]+(p[13]*x[155]*2.0)/p[4];
  y[52] = (p[12]*x[153])/p[4]+(p[12]*x[154])/p[4]+(p[12]*x[155]*2.0)/p[4];
}

} // namespace model_model_jakstat_adjoint_o2

} // namespace amici

